--
--             This file is part of the New World OS project
--                    Copyright (C) 2009  QRW Software
--           J. Scott Edwards - j.scott.edwards.nwos@gmail.com 
--                      http://www.qrwsoftware.com
--                      http://nwos.sourceforge.com
--
--   This program is free software: you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation, either version 3 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program, in the file LICENSE.  If not, see 
--   <http://www.gnu.org/licenses/>.
--
--   You can also contact me via paper mail at:
--
--      QRW Software
--      P.O. Box 27511
--      Salt Lake City, UT 84127-0511, USA.
--
-- This program is a quick hack to output a random line from the lines
-- fed to it via the standard input.  I used it temporarily in the
-- test_remove_file.sh script.
--
-- $Log: random_line.e,v $
-- Revision 1.1  2009/01/21 15:42:35  jsedwards
-- Initial version (quick hack).
--

class RANDOM_LINE

creation make

feature

   make is
      local
         lines: FIXED_ARRAY[STRING]
         line: STRING
         temp: STRING
         rand: INTEGER
      do
         !!lines.with_capacity(2048)
         !!line.make(1024)

         from
            std_input.read_line_in(line)
         until
            std_input.end_of_input
         loop
            !!temp.copy(line)
            lines.add_last(temp)

            std_input.read_line_in(line)
         end

--         std_output.put_string("Lines: ")
--         std_output.put_integer(lines.count)
--         std_output.put_new_line

         random_number_generator.next
	 rand := random_number_generator.last_integer(lines.lower + 2, lines.upper - 1)

--         std_output.put_string("Rand: ")
--         std_output.put_integer(rand)
--         std_output.put_new_line

         std_output.put_string(lines.item(rand))
	 std_output.put_new_line
      end

end

